<!DOCTYPE html>
<html lang="en">

<head>
    <title>Post List </title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="container">
        <div class="text-center my-4">
            <h3 class="text-info">Danh sách bài đăng của người dùng (POSTS OF USERS)</h3>
        </div>
        <div class="row form-group">
            <div class="col-sm-2">
                <label class="form-control border border-0 text-dark"> Điền user id: </label>
            </div>
            <div class="col-sm-6">
                <input type="text" class="form-control" id="inp-user-id" placeholder="Gợi ý user id đúng: 3, 4, 5...">
            </div>
            <div class="col-sm-4">
                <button class="btn btn-info form-control" id="btn-get-user-posts"> Lấy danh sách bài viết (post)
                </button>
            </div>
        </div>
        <table class="table table-bordered table-striped table-hover" id="tbl-user-posts">
            <thead>
                <tr>
                    <th>ID</th>
                    <th>Post ID</th>
                    <th>Post title (nhan đề)</th>
                    <th>Post body (nội dung)</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>

    <script>
        "use strict";

        /*** REGION 1 - Global variables - Vùng khai báo hằng số, tham số TOÀN CỤC */
        const gCOL_ID = 0;
        const gCOL_POSTID = 1;
        const gCOL_POSTTITLE = 2;
        const gCOL_POSTBODY = 3;
        const gCOL_ACTION = 4

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        $(document).ready(function () {
            //gán event handler cho nút 
            $("#btn-get-user-posts").click(onBtnGetUserPostsClick);
        });

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // hàm xử lý sự kiện lấy post của người dùng (4 bước xử lý)
        function onBtnGetUserPostsClick() {
            //1.đọc dữ liệu
            var vUserIdObject = { userId: 0 };
            readDataUserIdObject(vUserIdObject);
            //2.kiểm tra
            var vKetQuaKiemTra = validateUserIdObject(vUserIdObject);
            if (vKetQuaKiemTra) {
                //3. gọi server 
                //base url
                const vURL_GET_POST = "https://jsonplaceholder.typicode.com/posts/" + vUserIdObject.userId + "/comments";
                $.ajax({
                    url: vURL_GET_POST,
                    type: 'GET',
                    dataType: 'json', // added data type
                    success: function (responseObject) {
                        console.log(JSON.stringify(responseObject));  //response text
                        //4 xử lý hiện thị
                        loadTableUserPostData(responseObject)  // responseObject là array các posts
                    },
                    error: function (ajaxContext) {
                        alert(ajaxContext.responseText)
                    }
                });
            }
        }

        //hàm xử lý sự kiện click button detail
        function onDetailButtonClick(paramSuKienClick) {
            console.log("%cDetail button click. Sự kiện Click là: ....", "color:orange");
            var vButtonBiAn = paramSuKienClick.currentTarget;
            const vFORM_TO_OPEN = "520PostDetail.html"  //đây là form sẽ mở
            var vUrlToOpenPage = vFORM_TO_OPEN + "?"
                + "id=" + $(vButtonBiAn).data("id") + "&" + "postid=" + $(vButtonBiAn).data("postid");
            window.location.href = vUrlToOpenPage;
        }

        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        //hàm reset (xóa) dữ liệu của bảng user
        function resetTableData() {
            $("#tbl-user-posts tbody").html("");  //truy câp bảng, rồi truy cập tbody, và xóa hết
        }

        //hàm load dữ liệu lên table
        function loadTableUserPostData(paramPosts) {
            //xóa dữ liệu của bảng
            resetTableData();
            //đổ dữ liệu
            for (var bI = 0; bI < paramPosts.length; bI++) {
                //tạo row
                var bNewRow = $("<tr>").appendTo($("#tbl-user-posts  tbody"));
                // tao cell  
                $("<td>").html(paramPosts[bI].id)
                    .appendTo(bNewRow);//append vào hàng mới

                $("<td>").html(paramPosts[bI].postId)
                    .appendTo(bNewRow);

                $("<td>").html(paramPosts[bI].email)
                    .appendTo(bNewRow);

                $("<td>").html(paramPosts[bI].name)
                    .appendTo(bNewRow);

                $("<td>").html(paramPosts[bI].body)
                    .appendTo(bNewRow);

                // xử lý cột action (có nút)
                var bColAction = $("<td>").addClass("btn-group").appendTo(bNewRow);//cột action
                /* nút chi tiết */
                var bDetailButton = $("<button>", { html: "Chi tiết" })
                    .addClass('btn btn-info')
                    .data("id", paramPosts[bI].id)          
                    .appendTo(bColAction);
                // thêm sự kiện cho nút này
                bDetailButton.click(onDetailButtonClick);
            }
        }
        // read data
        function readDataUserIdObject(paramUserIdObject) {
            paramUserIdObject.userId = parseInt($("#inp-user-id").val().trim());
        }

        // validate data
        function validateUserIdObject(paramUserIdObject) {
            if (isNaN(paramUserIdObject.userId)) {
                alert("Dữ liệu userId phải nhập vào là số !");
                return false;
            }

            return true;
        }
    </script>
</body>

</html>